IO_FBYTE        equ     $301
IO_FLINE        equ     $302
IO_SBYTE        equ     $305
FS_POSAB        equ     $342
FS_POSRE        equ     $343
FS_HEADR        equ     $347
UT_MTEXT        equ     $d0
BP_INIT         equ     $110
CA_GTINT        equ     $112
CA_GTSTR        equ     $116
CA_GTLIN        equ     $118
NO_ERROR        equ     0
THIS_JOB        equ     -1
TIMEOUT         equ     -1
ERR_BO          equ     -5
ERR_NO          equ     -6
ERR_EF          equ     -10
ERR_BP          equ     -15
COUNTP          equ     8
COUNTF          equ     7
BV_CHBAS        equ     $30
BV_CHP          equ     $34
BV_RIP          equ     $58
START           lea     TABLE,a1
                move.w  BP_INIT,a2
                jsr     (a2)
                moveq   #0,d0
                move.b  #$80,$8f(a6)
                rts
TABLE           dc.w    COUNTP
                dc.w    put-*
                dc.b    3,'PUT'
                dc.w    put_w-*
                dc.b    5,'PUT_W'
                dc.w    put_l-*
                dc.b    5,'PUT_L'
                dc.w    put_s-*
                dc.b    5,'PUT_S'
                dc.w    put_n-*
                dc.b    7,'PUT_NEW'
                dc.w    put_a-*
                dc.b    7,'PUT_ABS'
                dc.w    put_r-*
                dc.b    7,'PUT_REL'
                dc.w    help-*
                dc.b    5,'FHELP'
                dc.w    0
                dc.w    countf
                dc.w    get_b-*
                dc.b    3,'GET'
                dc.w    get_w-*
                dc.b    5,'GET_W'
                dc.w    get_l-*
                dc.b    5,'GET_L'
                dc.w    get_s-*
                dc.b    5,'GET_S'
                dc.w    get_p-*
                dc.b    7,'GET_POS'
                dc.w    get_le-*
                dc.b    7,'GET_LEN'
                dc.w    get_t-*
                dc.b    7,'GET_TYP'
                dc.w    0
WHAT_CHANNEL    moveq   #1,d6
                cmpa.l  a3,a5
                beq.s   DO_DEFAULT
                btst    #7,1(a6,a3.l)
                beq.s   DO_DEFAULT
                move.l  a5,-(sp)
                movea.l a3,a5
                addq.l  #8,a5
                move.l  a5,-(sp)
                move.w  CA_GTINT,a2
                jsr     (a2)
                movea.l (sp)+,a3
                movea.l (sp)+,a5
                bne.s   ERROR
                move.w  0(a6,a1.l),d6
DO_DEFAULT      mulu    #$28,d6
                add.l   BV_CHBAS(a6),d6
                cmp.l   BV_CHP(a6),d6
                bhi.s   NOT_OPEN
                movea.l 0(a6,d6.l),a0
                moveq   #0,d0
ERROR           rts
CREATE_FP       movea.l BV_RIP(a6),a1
                bsr.s   CREATE_FP_1
                move.l  a1,BV_RIP(a6)
                moveq   #2,d4
                moveq   #NO_ERROR,d0
                rts
CREATE_FP_1     subq.l  #6,a1
                clr.w   0(a6,a1.l)
                tst.l   d1
                beq.s   CREATE_FP_3
                move.w  #$820,d2
CREATE_FP_2     subq.w  #1,d2
                asl.l   #1,d1
                bvc.s   CREATE_FP_2
                roxr.l  #1,d1
                move.w  d2,0(a6,a1.l)
CREATE_FP_3     move.l  d1,2(a6,a1.l)
                rts
NOT_OPEN        moveq   #ERR_NO,d0
                rts
BAD_PARAMETER   moveq   #ERR_BP,d0
                rts
PUT             bsr     WHAT_CHANNEL
                move.w  CA_GTINT,a2
                jsr     (a2)
                cmpi.b  #1,d3
                bne     BAD_PARAMETER
                move.b  1(a6,a1.l),d1
                moveq   #TIMEOUT,d3
                moveq   #IO_SBYTE&$FF,d0
                trap    #IO_SBYTE/$100
                rts
PUT_W           bsr     WHAT_CHANNEL
                move.w  CA_GTINT,a2
                jsr     (a2)
                cmpi.b  #1,d3
                bne     BAD_PARAMETER
                move.w  0(a6,a1.l),d1
                moveq   #TIMEOUT,d3
                move.w  d1,-(sp)
                ror.w   #8,d1
                moveq   #IO_SBYTE&$FF,d0
                trap    #IO_SBYTE/$100
                move.w  (sp)+,d1
                moveq   #IO_SBYTE&$FF,d0
                trap    #IO_SBYTE/$100
                rts
PUT_L           bsr     WHAT_CHANNEL
                move.w  CA_GTLIN,a2
                jsr     (a2)
                cmpi.b  #1,d3
                bne     BAD_PARAMETER
                move.l  0(a6,a1.l),d1
                moveq   #TIMEOUT,d3
                moveq   #3,d7
LOOP_01         rol.l   #8,d1
                move.l  d7,-(sp)
                move.l  d1,-(sp)
                moveq   #IO_SBYTE&$FF,d0
                trap    #IO_SBYTE/$100
                move.l  (sp)+,d1
                move.l  (sp)+,d7
                dbf     d7,LOOP_01
                rts
PUT_S           bsr     What_channel
                move.w  ca_gtstr,a2
                jsr     (a2)
                cmpi.b  #1,d3
                bne     bad_parameter
                lea     0(a6,a1.l),a1
                move.w  ut_mtext,a2
                jsr     (a2)
                rts
put_n           bsr     what_channel
                moveq   #10,d1
                moveq   #timeout,d3
                moveq   #io_sbyte&$FF,d0
                trap    #io_sbyte/$100
                rts
put_a           bsr     what_channel
                move.w  ca_gtlin,a2
                jsr     (a2)
                cmpi.b  #1,d3
                bne     bad_parameter
                move.l  0(a6,a1.l),d1
                moveq   #timeout,d3
                moveq   #fs_posab&$FF,d0
                trap    #fs_posab/$100
                rts
put_r           bsr     what_channel
                move.w  ca_gtlin,a2
                jsr     (a2)
                cmpi.b  #1,d3
                bne     bad_parameter
                move.l  0(a6,a1.l),d1
                moveq   #timeout,d3
                moveq   #fs_posre&$FF,d0
                trap    #fs_posre/$100
                rts
get_b           bsr     what_channel
                moveq   #0,d1
                moveq   #timeout,d3
                moveq   #io_fbyte&$FF,d0
                trap    #io_fbyte/$100
                bra     create_fp
get_w           bsr     what_channel
                moveq   #0,d1
                moveq   #timeout,d3
                moveq   #io_fbyte&$FF,d0
                trap    #io_fbyte/$100
                rol.w   #8,d1
                moveq   #io_fbyte&$FF,d0
                trap    #io_fbyte/$100
                bra     create_fp
get_l           bsr     what_channel
                moveq   #0,d1
                moveq   #timeout,d3
                move.l  #3,d7
loop_02         move.l  d7,-(sp)
                move.l  d1,-(sp)
                moveq   #io_fbyte&$FF,d0
                trap    #io_fbyte/$100
                move.l  (sp)+,d2
                or.b    d1,d2
                move.l  d2,d1
                rol.l   #8,d1
                move.l  (sp)+,d7
                dbf     d7,loop_02
                ror.l   #8,d1
                bra     create_fp
get_s           move.w  ca_gtlin,a2
                jsr     (a2)
                bne     error
                cmpi.b  #2,d3
                bne     bad_parameter
                move.l  0(a6,a1.l),d0
                mulu    #$28,d0
                movea.l bv_chbas(a6),a2
                adda.l  d0,a2
                cmpa.l  BV_CHP(A6),A2
                BHI     NOT_open
                movea.l 0(a6,a2.l),a0
                move.l  4(a6,a1.l),d2
                moveq   #timeout,d3
                lea     buffer,a1
                moveq   #io_fline&$FF,d0
                trap    #io_fline/$100
                cmpi.b  #err_bO,d0
                beq.s   buffer_Full
                cmpi.b  #ERR_EF,D0
                BEQ.S   BUFFER_FULL
                TST.L   D0
                bne     error
                subq.l  #1,d1
buffer_full     btst    #0,d1
                beq.s   copy_string
                addq.l#1,D1
                MOVEA.l bv_rip(a6),a1
                suba.l  d1,a1
                subq.l  #2,a1
                move.l  a1,bv_rip(a6)
                move.w  d1,0(a6,a1.l)
                lea     2(a6,a1.l),a4
                move.b  #32,-1(a4,d1.l)
                bra.s   copy_string_1
copy_string     movea.l bv_rip(a6),a1
                suba.l  d1,a1
                subq.l  #2,a1
                move.l  a1,bv_rip(a6)
                move.w  d1,0(a6,a1.l)
                lea     2(a6,a1.l),a4
copy_string_1   subq.l  #1,d1
                lea     buffer,a3
copy_string_2   move.b  (a3)+,(a4)+
                dbf     d1,copy_string_2
                moveq   #1,d4
                moveq   #no_error,d0
                rts
get_p           bsr     what_channel
                moveq   #timeout,d3
                moveq   #0,d1
                moveq   #fs_posre&$FF,d0
                trap    #fs_posre/$100
                tst.l   D0
                bne     error
                bra     create_fp
get_header      bsr     what_channel
                move.w  #64,d2
                moveq   #timeout,d3
                lea     buffer,a1
                moveq   #fs_headr&$FF,d0
                trap    #fs_headr/$100
                rts
get_t           bsr.s   get_header
                lea     buffer+5,a4
                moveq   #0,d1
                move.b  (a4),d1
                bra     create_fp
get_le          bsr.s   get_header
                lea     buffer,a4
                move.l  (a4),d1
                bra     create_fp
help            move.w  $c8,a2
                lea     win_head,a1
                jsr     (a2)
                move.w  $d0,a2
                lea     text_head,a1
                jsr     (a2)
                moveq   #2,d0
                trap    #2
                move.w  $c8,a2
                lea     window,a1
                jsr     (a2)
                move.w  $d0,a2
                lea     text,a1
                jsr     (a2)
                moveq   #2,d0
                trap    #2
                clr.l   d0
                move.b  #$80,$8f(a6)
                rts
window          dc.b    7,1,2,7
                dc.w    448,162,32,16
text            dc.w    TE2-TE1
TE1             dc.b    'PUT     #c,b   - Print Byte b to Channel #c',10
                dc.b    'PUT_W   #c,w   - Print Word w to Channel #c',10
                dc.b    'PUT_L   #c,l   - Print Long Word l to Channel #c',10
                dc.b    'PUT_S   #c,s$  - Print String s to Channel #c',10
                dc.b    'PUT_NEW #c     - Print Linefeed to Channel #c',10
                dc.b    '(GET    #c)    - Fetch Byte from Channel #c',10
                dc.b    '(GET_W  #c)    - Fetch Word from Channel #c',10
                dc.b    '(GET_L  #c)    - Fetch Long Word from Channel #c',10
                dc.b    '(GET_S  #c,l)  - Fetch String from Channel #c'
                dc.b    'with Length l, Followed by LF',10
                dc.b    '(GET_POS#c)    - Return Position of File Pointer'
                dc.b    ' on Channel #c',10
                dc.b    'PUT_ABS #c,a   - Set File Pointer on Channel #c '
                dc.b    'absolute',10
                dc.b    'PUT_REL #c,r   - Set File Pointer on Channel #c '
                dc.b    'relative',10
                dc.b    '(GET_LEN#c)    - Return File length of Channel'
                dc.b    ' #c',10
                dc.b    '(GET_TYP#c)    - Return File Type (0=BASIC'
                dc.b    ' or Data, 1=EXEC-Job)',10
                dc.b    'FHelp          - Show this screen...',10
                dc.b    'No brackets : PROCedure, in Brackets: '
                dc.b    'FuNction ...'
TE2
win_head        dc.b    2,1,7,0
                dc.w    448,12,32,2
text_head       dc.w    TH2-TH1
TH1             dc.b    'Help screen for FTOOL-Filehandling .....'
TH2
buffer          ds.b    312
  end
